package com.fullbattery.osgi.bootloader.intelhex;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class HexParser {

	protected List<Integer> hexData;

	public List<Integer> getHexData() {
		return hexData;
	}

	// protected List<Segment> segmentList;

	// public List<Segment> getSegmentList() {
	// return segmentList;
	// }
	public void loadHexFile(String fileName) throws IOException, HexParserException {
		FileReader fr = new FileReader(fileName);
		BufferedReader br = new BufferedReader(fr);
		loadHexFile(br);
		br.close();
		fr.close();
	}
	
	/**
	 * Läd das Hexfile in den internen Speicher.
	 * 
	 * @param fileName
	 * @throws IOException
	 * @throws HexParserException
	 */
	public void loadHexFile(BufferedReader br) throws IOException, HexParserException {

		hexData = new ArrayList<Integer>();
		// segmentList = new ArrayList<Segment>();

		int length;
		int address;
		int type;
		int check;

//		int[] segmentData = null;
//		int currentAddr = 0;
//		int startAddr = 0;

		int lineCount = 0;
		while (br.ready()) {
			lineCount++;
			
			if(lineCount == 100){
				System.out.println("");
			}
			
			String line = br.readLine();

			if (!line.substring(0, 1).equals(":")) {
				throw new HexParserException("File Format Error in line '"+lineCount+"'");
			}

			length = Integer.parseInt(line.substring(1, 3), 16);
			address = Integer.parseInt(line.substring(3, 7), 16);
			type = Integer.parseInt(line.substring(7, 9), 16);
			check = Integer.parseInt(line.substring(line.length() - 2), 16);

			if (line.length() != (11 + 2 * length)) {
				throw new HexParserException("Invaild Line Length in line '"+lineCount+"'");
			}

			// Checksumme überprüfen
			int checkSum = 0;
			for (int i = 1; i < line.length(); i = i + 2) {
				String c = line.substring(i, i + 2);
				int tmp = Integer.parseInt(c, 16);
				checkSum += tmp;
			}
			checkSum &= 0x0FF;
			
		
			if (checkSum != 0) {
				throw new HexParserException("Checksum Error in line '"+lineCount+"'");
			}

			if (type == 0x00) {
				// Data record

				// LINK: Wir koennen im Moment nur ein Segment
				// if (currentAddr != address){
				// segmentList.add(new Segment(startAddr, segmentData));
				// }
				// startAddr = currentAddr = address;
				// segmentData = new int[length];
				//				
				// for(int i=0; i<length;i++){
				// segmentData[i] = Integer.parseInt(line.substring(9+2*i,
				// 11+2*i), 16);
				// }
				// currentAddr = length+currentAddr;

				for (int i = 0; i < length; i++) {
					hexData.add(Integer.parseInt(line.substring(9 + 2 * i, 11 + 2 * i), 16));
				}
			} else if (type == 0x01) {
				// End of file record
				if (length == 0) {
					break;
				} else {
					throw new HexParserException("Invalid end of file record in line '"+lineCount+"'");
				}
			} else if (type == 0x02) {
				// Extended Segment address record. This indicates segment base
				// address when 16 bits is not enough for addressing memory;
			} else if (type == 0x03) {
				// Start segment address record. Indicates initial segment base
				// address.
			} else if (type == 0x04) {
				// Extended Linear Address Record allows 32 bit addressing
			} else if (type == 0x05) {
				// Start Linear Address Record
			}
		}
	}
}
