package com.fullbattery.osgi.bootloader.intelhex;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

public class TestHexParser {

	public final static String FILE = "/Volumes/data/Users/torstenlink/Documents/Data_no_backup/entwicklung/full-battery/trunk/java/osgi/com.fullbattery.osgi.bootloader/testData/ladekarte.hex"; 
	private static final int BL_COMMAND = 0xA5; // Command Sequence start
	private static final int BL_ESCAPE = BL_COMMAND;
	private static final int BL_ESC_SHIFT = 0x80; // offset escape char

	static FileOutputStream os;
	/**
	 * 
	 * @param args
	 * @throws IOException
	 * @throws HexParserException
	 */
	public static void main(String[] args) throws IOException, HexParserException {
		
		os = new FileOutputStream("javaOut.txt");
		
		HexParser parser = new HexParser();
		parser.loadHexFile(FILE);
		List<Integer> hexData = parser.getHexData();

		int i=0;
		StringBuffer buff = new StringBuffer();
		for(int hex : hexData){
			
			if ((hex == BL_ESCAPE) || (hex == 0x13)) {
				printVal(BL_ESCAPE);
				printVal(hex);
				printVal(BL_ESC_SHIFT);
			} else {
				printVal(hex);
			}

			
			String val = Integer.toHexString(hex);
			if(val.length() == 1){
				buff.append("0"+val+" ");
			}else{
				buff.append(Integer.toHexString(hex)+" ");
			}

			if(i >= 25){
				System.out.println(buff.toString());
				buff = new StringBuffer();
				i=0;
			}else{
				i++;
			}
		}
		
		os.close();
		System.out.println(buff.toString());
	}
	
	static void printVal(int hex) throws IOException{
		String lf = "\n";
		String prefix = "SENDEN Char = ";
		
		String intVal = Integer.toString(hex);
		os.write(prefix.getBytes());
		os.write(intVal.getBytes());
		os.write(lf.getBytes());		
	}
	
	
}
